Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncCu.cpp	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncCu.cpp	(revision 373)
@@ -64,5 +64,7 @@
   m_ppcBestCU      = new TComDataCU*[m_uhTotalDepth-1];
   m_ppcTempCU      = new TComDataCU*[m_uhTotalDepth-1];
-  
+#if QC_ARP_D0177
+  m_ppcWeightedTempCU = new TComDataCU*[m_uhTotalDepth-1];
+#endif 
   m_ppcPredYuvBest = new TComYuv*[m_uhTotalDepth-1];
   m_ppcResiYuvBest = new TComYuv*[m_uhTotalDepth-1];
@@ -91,5 +93,7 @@
     m_ppcBestCU[i] = new TComDataCU; m_ppcBestCU[i]->create( uiNumPartitions, uiWidth, uiHeight, false, uiMaxWidth >> (m_uhTotalDepth - 1) );
     m_ppcTempCU[i] = new TComDataCU; m_ppcTempCU[i]->create( uiNumPartitions, uiWidth, uiHeight, false, uiMaxWidth >> (m_uhTotalDepth - 1) );
-    
+#if QC_ARP_D0177
+    m_ppcWeightedTempCU[i] = new TComDataCU; m_ppcWeightedTempCU[i]->create( uiNumPartitions, uiWidth, uiHeight, false, uiMaxWidth >> (m_uhTotalDepth - 1) );
+#endif    
     m_ppcPredYuvBest[i] = new TComYuv; m_ppcPredYuvBest[i]->create(uiWidth, uiHeight);
     m_ppcResiYuvBest[i] = new TComYuv; m_ppcResiYuvBest[i]->create(uiWidth, uiHeight);
@@ -170,4 +174,10 @@
     {
       m_ppcResPredTmp [i]->destroy(); delete m_ppcResPredTmp[i];  m_ppcResPredTmp[i] = NULL;
+    }
+#endif
+#if QC_ARP_D0177
+    if(m_ppcWeightedTempCU[i])
+    {
+      m_ppcWeightedTempCU[i]->destroy(); delete m_ppcWeightedTempCU[i]; m_ppcWeightedTempCU[i] = NULL;
     }
 #endif
@@ -596,5 +606,9 @@
       if( rpcTempCU->getSlice()->getSliceType() != I_SLICE )
       {
+#if QC_ARP_D0177
+        if(( rpcTempCU->getSlice()->getSPS()->getMultiviewMvPredMode() || rpcTempCU->getSlice()->getSPS()->getUseAdvRP()) && rpcTempCU->getSlice()->getViewId())
+#else
         if(( rpcTempCU->getSlice()->getSPS()->getMultiviewMvPredMode() || rpcTempCU->getSlice()->getSPS()->getMultiviewResPredMode()) && rpcTempCU->getSlice()->getViewId())
+#endif
         {  
           PartSize ePartTemp = rpcTempCU->getPartitionSize(0);
@@ -624,6 +638,17 @@
       {
 #if H3D_IVRP
+#if QC_ARP_D0177
+        Bool  bResPredAvailable   = false;
+        Bool  bResPredAllowed     =                    (!rpcBestCU->getSlice()->getSPS()->isDepth                () );
+        bResPredAllowed           = bResPredAllowed && ( rpcBestCU->getSlice()->getSPS()->getViewId              () );
+        if( bResPredAllowed )
+        {
+          bResPredAvailable       = rpcBestCU->getResidualSamples( 0, true, m_ppcResPredTmp[uiDepth] );
+        }
+        for( UInt uiResPrdId = 0; uiResPrdId < (rpcBestCU->getSlice()->getSPS()->getUseAdvRP()? 1: ( bResPredAvailable ? 2 : 1 )); uiResPrdId++ )
+#else
         Bool  bResPredAvailable   = false;
         UInt uiResPrdId = 0; 
+#endif
         {
           Bool bResPredFlag  = ( uiResPrdId > 0 );
@@ -743,6 +768,17 @@
       {
 #if H3D_IVRP
+#if QC_ARP_D0177
+        Bool  bResPredAvailable   = false;
+        Bool  bResPredAllowed     =                    (!rpcBestCU->getSlice()->getSPS()->isDepth                () );
+        bResPredAllowed           = bResPredAllowed && ( rpcBestCU->getSlice()->getSPS()->getViewId              () );
+        if( bResPredAllowed )
+        {
+          bResPredAvailable       = rpcBestCU->getResidualSamples( 0, true, m_ppcResPredTmp[uiDepth] );
+        }
+        for( UInt uiResPrdId = 0; uiResPrdId < (rpcBestCU->getSlice()->getSPS()->getUseAdvRP()? 1: ( bResPredAvailable ? 2 : 1 )); uiResPrdId++ )
+#else
         Bool  bResPredAvailable   = false;
         UInt uiResPrdId = 0; 
+#endif
         {
           Bool bResPredFlag  = ( uiResPrdId > 0 );
@@ -1795,4 +1831,7 @@
         );
 #endif
+#if QC_ARP_D0177
+    m_pcEntropyCoder->encodeARPW( pcCU , uiAbsPartIdx, 0, uiDepth);
+#endif
     finishCU(pcCU,uiAbsPartIdx,uiDepth);
     return;
@@ -1861,4 +1900,8 @@
   Int numValidMergeCand = 0;
 
+#if QC_ARP_D0177
+  Bool  bResPrdAvail  = rpcTempCU->getResPredAvail( 0 );
+  Bool  bResPrdFlag   = rpcTempCU->getResPredFlag ( 0 );
+#endif
 #if LGE_ILLUCOMP_B0045
   Bool  bICFlag = rpcTempCU->getICFlag(0);
@@ -1893,10 +1936,16 @@
   rpcTempCU->getInterMergeCandidates( 0, 0, uhDepth, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand );
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   Bool bResPredAvail = rpcTempCU->getResPredAvail(0);
 #endif
 
   Bool bestIsSkip = false;
-  
+#if QC_ARP_D0177
+  Int nGRPW = rpcTempCU->getSlice()->getARPStepNum() - 1;
+  if(nGRPW < 0 || !bResPrdAvail )
+    nGRPW = 0;
+  for( ; nGRPW >= 0 ; nGRPW-- )
+  {
+#endif  
   for( UInt uiMergeCand = 0; uiMergeCand < numValidMergeCand; ++uiMergeCand )
   {
@@ -1932,4 +1981,8 @@
           rpcTempCU->setPredModeSubParts( MODE_SKIP, 0, uhDepth ); // interprets depth relative to LCU level
           rpcTempCU->setPartSizeSubParts( SIZE_2Nx2N, 0, uhDepth ); // interprets depth relative to LCU level
+#if QC_ARP_D0177
+          if(rpcTempCU->getSlice()->getSPS()->getUseAdvRP())
+            rpcTempCU->setARPWSubParts( ( UChar )nGRPW , 0 , uhDepth );
+#endif
           rpcTempCU->setMergeFlagSubParts( true, 0, 0, uhDepth ); // interprets depth relative to LCU level
           rpcTempCU->setMergeIndexSubParts( uiMergeCand, 0, 0, uhDepth ); // interprets depth relative to LCU level
@@ -1955,10 +2008,31 @@
 
 #if H3D_IVRP
+#if !QC_ARP_D0177
           rpcTempCU->setResPredAvailSubParts(bResPredAvail, 0, 0, uhDepth);
+#else
+          rpcTempCU->setResPredAvailSubParts( bResPrdAvail, 0, 0, uhDepth );
+          rpcTempCU->setResPredFlagSubParts ( bResPrdFlag,  0, 0, uhDepth );
+#endif  
 #endif
 #if LGE_ILLUCOMP_B0045
           rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uhDepth);
 #endif
-
+#if QC_ARP_D0177
+          if(rpcTempCU->getSlice()->getSPS()->getUseAdvRP())
+          {
+            bool bSignalflag[2] = {true, true};
+            for(UInt uiRefListIdx = 0; uiRefListIdx < 2; uiRefListIdx ++ )
+            {
+              Int iRefIdx = cMvFieldNeighbours[uiRefListIdx + 2*uiMergeCand].getRefIdx();
+              RefPicList eRefList = uiRefListIdx ? REF_PIC_LIST_1 : REF_PIC_LIST_0;
+              if(iRefIdx < 0 || rpcTempCU->getSlice()->getPOC() == rpcTempCU->getSlice()->getRefPOC(eRefList, iRefIdx))
+                bSignalflag[uiRefListIdx] = false;
+            }
+            if(!bSignalflag[0]&& !bSignalflag[1])
+            {
+              rpcTempCU->setARPWSubParts( 0 , 0 , uhDepth );
+            }
+          }
+#endif
           // do MC
 #if HHI_INTERVIEW_SKIP
@@ -1973,5 +2047,5 @@
             m_pcPredSearch->motionCompensation ( rpcTempCU, m_ppcPredYuvTemp[uhDepth] );
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
             if (uiMergeCand == 0 && rpcTempCU->getResPredAvail(0))
             {
@@ -1992,5 +2066,5 @@
               m_pcPredSearch->motionCompensation ( rpcTempCU, m_ppcPredYuvTemp[uhDepth] );
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
               if (uiMergeCand == 0 && rpcTempCU->getResPredAvail(0))
               {
@@ -2049,4 +2123,7 @@
     }
   }
+#if QC_ARP_D0177
+  }
+#endif
 }
 
@@ -2066,5 +2143,17 @@
 {
   UChar uhDepth = rpcTempCU->getDepth( 0 );
-  
+#if QC_ARP_D0177
+  Bool bFirstTime = true;
+  Int nARPWMax = rpcTempCU->getSlice()->getARPStepNum() - 1;
+  if(nARPWMax < 0 || !rpcTempCU->getResPredAvail( 0 ) )
+    nARPWMax = 0;
+  if( ePartSize != SIZE_2Nx2N)
+    nARPWMax = 0;
+  Int nARPWStart = 0 , nARPWStep = 1;
+  for( Int nCount = 0 , nGRPW = nARPWStart ; nCount <= nARPWMax ; nCount++ , nGRPW += nARPWStep )
+  {
+    if( bFirstTime == false && rpcTempCU->getSlice()->getSPS()->getUseAdvRP() )
+      rpcTempCU->initEstData( rpcTempCU->getDepth(0), rpcTempCU->getQP(0) );
+#endif  
 #if HHI_VSO
   if( m_pcRdCost->getUseRenModel() )
@@ -2093,4 +2182,37 @@
   rpcTempCU->setPredModeSubParts  ( MODE_INTER, 0, uhDepth );
 
+#if QC_ARP_D0177
+  if(rpcTempCU->getSlice()->getSPS()->getUseAdvRP())
+    rpcTempCU->setARPWSubParts( ( UChar )nGRPW , 0 , uhDepth );
+#endif
+#if QC_ARP_D0177
+  if( bFirstTime == false && rpcTempCU->getSlice()->getSPS()->getUseAdvRP())
+  {
+    assert(!rpcTempCU->getSlice()->getSPS()->isDepth());
+    rpcTempCU->copyPartFrom( m_ppcWeightedTempCU[uhDepth] , 0 , uhDepth, true );
+    rpcTempCU->setARPWSubParts( ( UChar )nGRPW , 0 , uhDepth );
+#if MERL_VSP_C0152
+    m_pcPredSearch->motionCompensation( rpcTempCU , m_ppcPredYuvTemp[uhDepth], 0);
+#else
+    m_pcPredSearch->motionCompensation( rpcTempCU , m_ppcPredYuvTemp[uhDepth] );
+#endif
+    if(rpcTempCU->getPartitionSize(0)==SIZE_2Nx2N)
+    {
+      bool bSignalflag[2] = {true, true};
+      for(UInt uiRefListIdx = 0; uiRefListIdx < 2; uiRefListIdx ++ )
+      {
+        RefPicList eRefList = uiRefListIdx ? REF_PIC_LIST_1 : REF_PIC_LIST_0;
+        Int iRefIdx = rpcTempCU->getCUMvField(eRefList)->getRefIdx(0);
+        if(iRefIdx < 0 || rpcTempCU->getSlice()->getPOC() == rpcTempCU->getSlice()->getRefPOC(eRefList, iRefIdx))
+          bSignalflag[uiRefListIdx] = false;
+      }
+      if(!bSignalflag[0]&& !bSignalflag[1])
+        rpcTempCU->setARPWSubParts( 0 , 0 , uhDepth );
+    }
+  }
+  else
+  {
+    bFirstTime = false;
+#endif
 #if AMP_MRG
   rpcTempCU->setMergeAMP (true);
@@ -2107,8 +2229,33 @@
 #endif
 #endif
+#if QC_ARP_D0177
+   if(rpcTempCU->getSlice()->getSPS()->getUseAdvRP())
+   {
+     m_ppcWeightedTempCU[uhDepth]->copyPartFrom( rpcTempCU , 0 , uhDepth );
+     if(rpcTempCU->getSlice()->getSPS()->getUseAdvRP() && rpcTempCU->getPartitionSize(0)==SIZE_2Nx2N)
+     {
+       bool bSignalflag[2] = {true, true};
+       for(UInt uiRefListIdx = 0; uiRefListIdx < 2; uiRefListIdx ++ )
+       {
+         RefPicList eRefList = uiRefListIdx ? REF_PIC_LIST_1 : REF_PIC_LIST_0;
+         Int iRefIdx = rpcTempCU->getCUMvField(eRefList)->getRefIdx(0);
+         if(iRefIdx < 0 || rpcTempCU->getSlice()->getPOC() == rpcTempCU->getSlice()->getRefPOC(eRefList, iRefIdx))
+           bSignalflag[uiRefListIdx] = false;
+       }
+       if(!bSignalflag[0]&& !bSignalflag[1])
+         rpcTempCU->setARPWSubParts( 0 , 0 , uhDepth );
+     }
+   }
+  }
+#endif
 
 #if AMP_MRG
   if ( !rpcTempCU->getMergeAMP() )
   {
+#if QC_ARP_D0177
+    if(rpcTempCU->getSlice()->getSPS()->getUseAdvRP())
+      continue;
+    else
+#endif
     return;
   }
@@ -2151,4 +2298,7 @@
   xCheckDQP( rpcTempCU );
   xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth);
+#if QC_ARP_D0177
+  }
+#endif
 }
 
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncCu.h
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncCu.h	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncCu.h	(revision 373)
@@ -69,4 +69,7 @@
   TComDataCU**            m_ppcBestCU;      ///< Best CUs in each depth
   TComDataCU**            m_ppcTempCU;      ///< Temporary CUs in each depth
+#if QC_ARP_D0177
+  TComDataCU**            m_ppcWeightedTempCU;   
+#endif
   UChar                   m_uhTotalDepth;
   
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 373)
@@ -456,4 +456,34 @@
 
 
+#if QC_ARP_D0177
+Void TEncEntropy::encodeARPW( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD, UInt uiDepth)
+{
+  if( pcCU->getSlice()->getViewId() == 0 || pcCU->getSlice()->getIsDepth() == true || !pcCU->getSlice()->getARPStepNum() )
+  {
+    return;
+  }
+  assert( pcCU->isIntra( uiAbsPartIdx ) == false );
+  if( bRD )
+  {
+    uiAbsPartIdx = 0;
+  }
+  bool bSignalflag[2] = {true, true};
+  if (!(pcCU->getPartitionSize(uiAbsPartIdx)==SIZE_2Nx2N || pcCU->isSkipped(uiAbsPartIdx)))
+  {
+    assert(pcCU->getARPW (uiAbsPartIdx) == 0);
+    bSignalflag[0] = false;
+    bSignalflag[1] = false;
+ }
+  if (!(bSignalflag[0]|| bSignalflag[1]))
+  {
+    assert(pcCU->getARPW (uiAbsPartIdx) == 0);
+    if (uiDepth != -1)
+      pcCU->setARPWSubParts(0, uiAbsPartIdx, uiDepth);
+  }
+  else
+     m_pcEntropyCoderIf->codeARPW( pcCU, uiAbsPartIdx );
+ 
+}
+#endif
 /** parse the fixed length code (smaller than one max value) in ALF
  * \param run: coded value
@@ -1233,4 +1263,7 @@
   {
     encodePUWise( pcCU, uiAbsPartIdx, bRD );
+#if QC_ARP_D0177
+    encodeARPW( pcCU , uiAbsPartIdx , bRD );
+#endif
   }
 }
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncEntropy.h
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncEntropy.h	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncEntropy.h	(revision 373)
@@ -117,4 +117,7 @@
   virtual Void codeResPredFlag   ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
 #endif
+#if QC_ARP_D0177
+  virtual Void codeARPW         ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
+#endif
   virtual Void codeSplitFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth ) = 0;
   
@@ -250,4 +253,7 @@
   Void encodeMergeFlag    ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPUIdx );
   Void encodeMergeIndex   ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPUIdx, Bool bRD = false );
+#if QC_ARP_D0177
+  Void encodeARPW              ( TComDataCU* pcCU, UInt uiAbspartIdx , Bool bRD = false, UInt uiDepth = -1);
+#endif
   Void encodeAlfCtrlFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
 
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 373)
@@ -78,5 +78,5 @@
   m_pcDepthMapGenerator = NULL;
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   m_pcResidualGenerator = NULL;
 #endif
@@ -131,5 +131,5 @@
   m_pcDepthMapGenerator  = pcTEncTop->getDepthMapGenerator();
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   m_pcResidualGenerator  = pcTEncTop->getResidualGenerator();
 #endif
@@ -390,5 +390,12 @@
       std::vector<TComPic*> apcInterViewRefPics = tAppEncTop->getInterViewRefPics( m_pcEncTop->getViewId(), pcSlice->getPOC(), m_pcEncTop->getIsDepth(), pcSlice->getSPS() );
       pcSlice->setRefPicListMvc( rcListPic, apcInterViewRefPics );
-
+#if QC_ARP_D0177
+      pcSlice->setARPStepNum();
+      if(pcSlice->getARPStepNum() > 1)
+      {
+        for(Int iViewIdx = 0; iViewIdx < pcSlice->getViewId(); iViewIdx ++ )
+          pcSlice->setBaseViewRefPicList( tAppEncTop->getTEncTop( iViewIdx , false )->getListPic(), iViewIdx );
+      }
+#endif
       //  Slice info. refinement
       if( pcSlice->getSliceType() == B_SLICE )
@@ -754,5 +761,5 @@
       m_pcDepthMapGenerator->covertOrgDepthMap( pcPic );
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
       m_pcResidualGenerator->initViewComponent( pcPic );
 #endif
@@ -818,5 +825,5 @@
       pcSlice = pcPic->getSlice(0);
 
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
       // set residual picture
       m_pcResidualGenerator->setRecResidualPic( pcPic );
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncGOP.h
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncGOP.h	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncGOP.h	(revision 373)
@@ -97,5 +97,5 @@
   TComDepthMapGenerator*  m_pcDepthMapGenerator;
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   TComResidualGenerator*  m_pcResidualGenerator;
 #endif
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 373)
@@ -72,4 +72,7 @@
 #if H3D_IVRP
 , m_cResPredFlagSCModel       ( 1,             1,               NUM_RES_PRED_FLAG_CTX         , m_contextModels + m_numContextModels, m_numContextModels)
+#endif
+#if QC_ARP_D0177
+, m_cCUPUARPW                 ( 1,             1,               NUM_ARPW_CTX                 , m_contextModels + m_numContextModels, m_numContextModels)
 #endif
 , m_cCUPartSizeSCModel        ( 1,             1,               NUM_PART_SIZE_CTX             , m_contextModels + m_numContextModels, m_numContextModels)
@@ -158,4 +161,7 @@
   m_cResPredFlagSCModel.initBuffer       ( eSliceType, iQp, (UChar*)INIT_RES_PRED_FLAG );
 #endif
+#if QC_ARP_D0177
+  m_cCUPUARPW.initBuffer                 ( eSliceType, iQp, (UChar*)INIT_ARPW );
+#endif
   m_cCUPartSizeSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_PART_SIZE );
   m_cCUAMPSCModel.initBuffer             ( eSliceType, iQp, (UChar*)INIT_CU_AMP_POS );
@@ -311,4 +317,7 @@
   m_cResPredFlagSCModel.initBuffer       ( eSliceType, iQp, (UChar*)INIT_RES_PRED_FLAG );
 #endif
+#if QC_ARP_D0177
+  m_cCUPUARPW.initBuffer                 ( eSliceType, iQp, (UChar*)INIT_ARPW );
+#endif
   m_cCUPartSizeSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_PART_SIZE );
   m_cCUAMPSCModel.initBuffer             ( eSliceType, iQp, (UChar*)INIT_CU_AMP_POS );
@@ -840,5 +849,22 @@
 }
 #endif
-
+#if QC_ARP_D0177
+Void TEncSbac::codeARPW( TComDataCU* pcCU, UInt uiAbsPartIdx )
+{
+  Int nW = pcCU->getARPW( uiAbsPartIdx );
+  Int nMaxW = pcCU->getSlice()->getARPStepNum() - 1;
+  assert( 0 <= nW && nW <= nMaxW );
+  assert(nMaxW > 0);
+  if( nMaxW > 0 )
+  {
+    Int nOffset = pcCU->getCTXARPWFlag(uiAbsPartIdx);
+    assert( 0 <= nOffset && nOffset <= 2 );
+    Int nBinNum = nW + ( nW != nMaxW );
+    m_pcBinIf->encodeBin( nW != 0 , m_cCUPUARPW.get( 0, 0, 0 + nOffset ) );
+    if( nBinNum > 1 )
+       m_pcBinIf->encodeBin( nW == nMaxW , m_cCUPUARPW.get( 0, 0, 3 ) );
+  }
+}
+#endif
 Void TEncSbac::codeSplitFlag   ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncSbac.h
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncSbac.h	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncSbac.h	(revision 373)
@@ -209,4 +209,7 @@
   Void codeResPredFlag   ( TComDataCU* pcCU, UInt uiAbsPartIdx );
 #endif
+#if QC_ARP_D0177
+  virtual Void codeARPW ( TComDataCU* pcCU, UInt uiAbsPartIdx );
+#endif
   Void codeSplitFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
 #if H3D_IVMP
@@ -265,4 +268,7 @@
 #if H3D_IVRP
   ContextModel3DBuffer m_cResPredFlagSCModel;
+#endif
+#if QC_ARP_D0177
+  ContextModel3DBuffer m_cCUPUARPW;
 #endif
   ContextModel3DBuffer m_cCUPartSizeSCModel;
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 373)
@@ -4674,4 +4674,7 @@
 #endif
       );
+#if QC_ARP_D0177
+    m_pcEntropyCoder->encodeARPW       ( pcCU , 0 , true );
+#endif
 #endif
 #if HHI_MPI
@@ -5954,4 +5957,7 @@
       );
 #endif
+#if QC_ARP_D0177
+    m_pcEntropyCoder->encodeARPW( pcCU , 0 , true );
+#endif
     ruiBits += m_pcEntropyCoder->getNumberOfWrittenBits();
   }
@@ -5977,4 +5983,7 @@
 #endif
       );
+#if QC_ARP_D0177
+    m_pcEntropyCoder->encodeARPW( pcCU , 0 , true );
+#endif
 #endif
 #if HHI_MPI
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncTop.cpp	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncTop.cpp	(revision 373)
@@ -120,5 +120,5 @@
   m_cDepthMapGenerator. create( false, getSourceWidth(), getSourceHeight(), g_uiMaxCUDepth, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiBitDepth + g_uiBitIncrement, PDM_SUB_SAMP_EXP_X(m_uiPredDepthMapGeneration), PDM_SUB_SAMP_EXP_Y(m_uiPredDepthMapGeneration) );
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   m_cResidualGenerator. create( false, getSourceWidth(), getSourceHeight(), g_uiMaxCUDepth, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiBitDepth + g_uiBitIncrement );
 #endif
@@ -251,5 +251,5 @@
   m_cDepthMapGenerator. destroy();
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   m_cResidualGenerator. destroy();
 #endif
@@ -347,5 +347,5 @@
 #endif
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   m_cResidualGenerator.init( &m_cTrQuant, &m_cDepthMapGenerator );
 #endif
@@ -722,6 +722,12 @@
 #endif
 #if H3D_IVRP
+#if QC_ARP_D0177
+    m_cSPS.setUseAdvRP              ( 0 );
+    m_cSPS.setARPStepNum            ( 1 );
+#else
     m_cSPS.setMultiviewResPredMode  ( 0 );
 #endif
+#endif
+
   }
   else
@@ -742,5 +748,10 @@
 #endif
 #if H3D_IVRP
-      m_cSPS.setMultiviewResPredMode  ( m_uiMultiviewResPredMode );
+#if QC_ARP_D0177
+     m_cSPS.setUseAdvRP  ( m_viewId > 0   ? m_nUseAdvResPred : 0 );
+     m_cSPS.setARPStepNum( m_viewId > 0   ? QC_ARP_WFNR      : 1 );
+#else
+     m_cSPS.setMultiviewResPredMode  ( m_uiMultiviewResPredMode );
+#endif
 #endif
     }
@@ -751,5 +762,10 @@
 #endif
 #if H3D_IVRP
+#if QC_ARP_D0177
+      m_cSPS.setUseAdvRP              ( 0 );
+      m_cSPS.setARPStepNum            ( 1 );
+#else
       m_cSPS.setMultiviewResPredMode  ( 0 );
+#endif
 #endif
     }
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncTop.h	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibEncoder/TEncTop.h	(revision 373)
@@ -103,5 +103,5 @@
   TComDepthMapGenerator   m_cDepthMapGenerator;           ///< depth map generator
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   TComResidualGenerator   m_cResidualGenerator;           ///< generator for residual pictures
 #endif
@@ -234,5 +234,5 @@
   TComDepthMapGenerator*  getDepthMapGenerator  () { return  &m_cDepthMapGenerator;   }
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   TComResidualGenerator*  getResidualGenerator  () { return  &m_cResidualGenerator;   }
 #endif
